from simpleSA import *
import random,math
WhileLoopMax=1000#永久ループとみなす回数
def setWhileLoopMax(N):#■永久ループとみなす回数設定
    global WhileLoopMax 
    WhileLoopMax=N
def searchVL(name,VL):#■変数リストのサーチ
    for i in range(len(VL)):
        if VL[i][0]==name: return VL[i][1]
    print("変数名エラー",name,VL);return 0
def maxProc(V):
    if isinstance(V, list):
        R=V[0]
        for i in range(1,len(V)):
            if V[i]>R:R=V[i]
        return R
    else: return V
def minProc(V):
    if isinstance(V, list):
        R=V[0]
        for i in range(1,len(V)):
            if V[i]<R:R=V[i]
        return R
    else: return V
def powProc(V):
    if not isinstance(V, list):return V
    return math.pow(V[0],V[1])
def exorProc(V1,V2):
    if ((V1!=0 and V2!=0)or
        (V1==0 and V2==0)):return 0
    return 1
def orProc(V1,V2):
    if V1==0 and V2==0:return 0
    return 1
def andProc(V1,V2):
    if V1!=0 and V2!=0:return 1
    return 0
def exFunc(name,TR,VL):#■関数実行
    if TR[0][0]=="delm"and TR[0][1]==",":
            V=exComma(TR[1],TR[2],VL)
    else:   V=execTree(TR,VL);
    if name=="if":#if文
        if isinstance(V, list):
            R=execTree(V[0],VL)
            if R!=0: return execTree(V[1],VL)
            if len(V)>=3:return execTree(V[2],VL)
        else:return V
    if name=="while":#while文
        if isinstance(V, list):
            V=exComma(TR[1],TR[2],VL);R=0
            for k in range(WhileLoopMax):
                C=execTree(V[0],VL)
                if C==0:return R
                for i in range(1,len(V)):
                    R=execTree(V[i],VL)
            return 1E30#永久ループとみなす
        else:return V
    if name=="p":#複数個の関数を実行
        if isinstance(V, list):
            V=exComma(TR[1],TR[2],VL)
            for i in range(len(V)):
                #print(V[i])
                R=execTree(V[i],VL)
            return R #最後の実行を関数値とする
        else: return V
    if isinstance(V, list):
        EV=[]   #引数の評価リスト作成
        for i in range(len(V)):
            EV.append(execTree(V[i],VL))
        V=EV
    if name=="max":return maxProc(V)
    if name=="min":return minProc(V)
    if name=="pow":return powProc(V)
    #---以下，引数1個のみ有効
    if isinstance(V, list):V=V[0]    
    if name=="sin":return math.sin(V)
    if name=="cos":return math.cos(V)
    if name=="tan":return math.tan(V)
    if name=="exp":return math.exp(V)
    if name=="log":return math.log(V)
    if name=="int":return int(V)
    if name=="abs":return abs(V)
    if name=="print":print(V);return V
    print("関数名エラー");return 1E30
def exComma(TR1,TR2,VL):#コンマによるリスト生成
    if TR1[0][0]=="delm"and TR1[0][1]==",":
        return exComma(TR1[1],TR1[2],VL)+[TR2]
    return  [TR1]+[TR2]
def assignProc(TR1,TR2,VL):
    V=execTree(TR2,VL)
    if TR1[0]!="name":
        print("代入文エラー ", TR1)
        return V
    flag=True
    for i in range(len(VL)):
        if TR1[1]==VL[i][0]:
            flag=False;VL[i][1]=V
    if flag: VL.append([TR1[1],V])
    return V       
def exOpe(op,TR1,TR2,VL):#■演算子実行
    if op=="=":return assignProc(TR1,TR2,VL)
    V1=execTree(TR1,VL);V2=execTree(TR2,VL)
    if op=="+" :return  V1 +   V2
    if op=="-" :return  V1 -   V2
    if op=="*" :return  V1 *   V2
    if op=="/" :return  V1 /   V2
    if op=="%" :return  V1 %   V2
    if op=="**":return  math.pow(V1,V2)#実数を許容
    if op=="^" :return  exorProc(V1,V2)
    if op=="&" :return  andProc(V1,V2)
    if op=="|" :return  orProc(V1,V2)
    if op==">" :return  V1 >   V2
    if op==">=":return  V1 >=  V2
    if op=="<" :return  V1 <   V2
    if op=="<=":return  V1 <=  V2
    if op=="==":return  V1 ==  V2
    if op=="!=":return  V1 !=  V2
    print("演算子エラー");return 1E30
def execTree(TR,VL):#■構文木実行
    if TR[0]=="numb": return float(TR[1])     
    if TR[0]=="name": return searchVL(TR[1],VL)
    if TR[0][0]=="func": return exFunc(TR[0][1],TR[1],VL)
    if TR[0][0]=="delm":
        if TR[0][1]=="-$":return -execTree(TR[1],VL)
        if TR[0][1]=="+$":return execTree(TR[1],VL)
        return exOpe(TR[0][1],TR[1],TR[2],VL)
    print("内部エラー");return 0
def sourceToTree(src,debug=False):#■テキストを構文木に変換
    LA=procLA(src);SA= procSA(LA);Tree=genTree(SA)
    if debug:
        print("\nsource:", src)
        printLA("\nLA結果",LA)
        printPolish("\n逆ポーランド記法",SA)
        print("\n構文木");printTree(Tree)
    return Tree
def printVlist(VL):#■変数名リストの表示
    print("\n変数表\n\n   No.  変数名   値")
    print("--------------------------")
    for i in range(len(VL)):
        print("%5d %5s  %10.5f" % (i,VL[i][0],VL[i][1]))





            
            
                
                
                            
                
                
                
            

